--CREATE TABLE WITHOUT PRIMARY KEY
CREATE TABLE FARA82.CUSTOMER (
	CUST_ID	VARCHAR(10),
	CUST_FNAME	VARCHAR(50),
	CUST_LNAME	VARCHAR(50));

SELECT *
	FROM FARA82.SYSTABLES;

SELECT *
	FROM FARA82.SYSCOLUMNS
	WHERE TABLE_NAME = 'CUSTOMER';

SELECT *
	FROM FARA82.SYSCST;

DROP TABLE FARA82.CUSTOMER;

CREATE TABLE FARA82.REP (
	EMP_ID	VARCHAR(10),
	REP_FNAME	VARCHAR(50),
	REP_LNAME	VARCHAR(50),
	 CONSTRAINT FARA82.REP_PK PRIMARY KEY(EMP_ID));

--CREATE TABLE WITH COLUMN LEVEL PRIMARY KEY WITHOUT CONSTRAINT NAME
CREATE TABLE FARA82.CUSTOMER (
	CUST_ID	VARCHAR(10) PRIMARY KEY,
	CUST_FNAME	VARCHAR(50),
	CUST_LNAME	VARCHAR(50));

--CREATE TABLE WITH COLUMN LEVEL PRIMARY KEY WITH CONSTRAINT NAME
CREATE TABLE FARA82.CUSTOMER (
	CUST_ID	VARCHAR(10) 
		CONSTRAINT FARA82.CUSTOMER_PK PRIMARY KEY,
	CUST_FNAME	VARCHAR(50),
	CUST_LNAME	VARCHAR(50));

--CREATE TABLE WITH TABLE LEVEL PRIMARY KEY WITH CONSTRAINT NAME
CREATE TABLE FARA82.CUSTOMER (
	CUST_ID	VARCHAR(10),
	CUST_FNAME	VARCHAR(50),
	CUST_LNAME	VARCHAR(50),
	CONSTRAINT FARA82.CUSTOMER_PK PRIMARY KEY(CUST_ID));

--CREATE TABLE WITH TABLE LEVEL FOREIGN KEY WITH CONSTRAINT NAME
CREATE TABLE FARA82.CUSTOMER (
	CUST_ID	VARCHAR(10),
	CUST_FNAME	VARCHAR(50),
	CUST_LNAME	VARCHAR(50) ,
	REP_ID	VARCHAR(10) ,
	 CONSTRAINT FARA82.CUSTOMER_PK PRIMARY KEY(CUST_ID),
	CONSTRAINT FARA82.CUSTOMER_REP_FK FOREIGN KEY (REP_ID)
		REFERENCES  FARA82.REP(EMP_ID));

--CREATE TABLE WITH COLUMN LEVEL FOREIGN KEY WITH CONSTRAINT NAME
CREATE TABLE FARA82.CUSTOMER (
	CUST_ID	VARCHAR(10),
	CUST_FNAME	VARCHAR(50),
	CUST_LNAME	VARCHAR(50) NOT NULL,
	CITY	VARCHAR(30) DEFAULT 'TORONTO',
	ADDRESS	VARCHAR(50) CONSTRAINT FARA82.ADDRESS_UK UNIQUE,
	WH	VARCHAR(10) 
	REP_ID	VARCHAR(10) CONSTRAINT FARA82.CUSTOMER_REP_FK 
		REFERENCES  FARA82.REP(EMP_ID),
	 CONSTRAINT FARA82.CUSTOMER_PK PRIMARY KEY(CUST_ID));

CREATE TABLE FARA82.CUSTOMER (
	CUST_ID	VARCHAR(10),
	CUST_FNAME	VARCHAR(50),
	CUST_LNAME	VARCHAR(50) NOT NULL,
	CITY	VARCHAR(30) DEFAULT 'TORONTO',
	ADDRESS	VARCHAR(50),
	REP_ID	VARCHAR(10) CONSTRAINT FARA82.CUSTOMER_REP_FK 
		REFERENCES  FARA82.REP(EMP_ID),
	 CONSTRAINT FARA82.CUSTOMER_PK PRIMARY KEY(CUST_ID),
	 CONSTRAINT FARA82.ADDRESS_UK UNIQUE(ADDRESS));

CREATE TABLE FARA82.ORDER (
	ORDER_ID	VARCHAR(10),
	ORDER_DATE	DATE NOT NULL,
	 CONSTRAINT FARA82.ORDER_PK PRIMARY KEY(ORDER_ID));

CREATE TABLE FARA82.PRODUCT (
	PRODUCT_ID	VARCHAR(10),
	PRODUCT_NAME	VARCHAR(50) DEFAULT 'NOT KNOWN',
	 CONSTRAINT FARA82.PRODUCT_PK PRIMARY KEY(PRODUCT_ID));

CREATE TABLE FARA82.ORDER_DETAIL (
	ORDER_ID	VARCHAR(10),
	PRODUCT_ID	VARCHAR(10),
	 CONSTRAINT FARA82.ORDER_DETAIL_PK PRIMARY KEY(ORDER_ID, PRODUCT_ID));

INSERT INTO FARA82.REP (EMP_ID, REP_FNAME, REP_LNAME)
	VALUES('R100', 'FRANK', 'MALEKI');


SELECT *
	FROM FARA82.REP;

SELECT REP_FNAME, REP_LNAME
	FROM FARA82.REP;

SELECT *
	FROM FARA82.CUSTOMER;


INSERT INTO FARA82.CUSTOMER (CUST_ID, CUST_FNAME, CUST_LNAME, REP_ID)
	VALUES('C0001', 'FARHAD', 'POURHADI', 'R100');


INSERT INTO FARA82.CUSTOMER ( CUST_FNAME, CUST_ID,CUST_LNAME)
	VALUES('JANE', 'C0003', 'DOE');

INSERT INTO FARA82.CUSTOMER ( CUST_FNAME, CUST_ID,CUST_LNAME, REP_ID)
	VALUES('JANE', 'C0004', 'DOE', NULL);

INSERT INTO FARA82.CUSTOMER ( CUST_FNAME, CUST_ID,CUST_LNAME, REP_ID)
	VALUES('JANE', 'C0005', '', 'R100');

INSERT INTO FARA82.CUSTOMER ( CUST_FNAME, CUST_ID,CUST_LNAME, REP_ID)
	VALUES('JANE', 'C0006', NULL, 'R100');

INSERT INTO FARA82.CUSTOMER ( CUST_FNAME, CUST_ID,CUST_LNAME, REP_ID, ADDRESS)
	VALUES('JANE', 'C0006', 'POURHADI', 'R100', 'ANYWHERE ST');

INSERT INTO FARA82.CUSTOMER ( CUST_FNAME, CUST_ID,CUST_LNAME, REP_ID, CITY, ADDRESS)
	VALUES('JANE', 'C0007', 'POURHADI', 'R100', NULL, 'ANYWHERE ST');

INSERT INTO FARA82.CUSTOMER ( CUST_FNAME, CUST_ID,CUST_LNAME, REP_ID, CITY)
	VALUES('JANE', 'C0008', 'POURHADI', 'R100', '');


INSERT INTO FARA82.CUSTOMER 
	VALUES('C0002', 'MIKE', 'XXX', 'R100');

INSERT INTO FARA82.CUSTOMER 
	VALUES('C0005', 'MARYAM', '', 'R100');

SELECT *
	FROM FARA82.CUSTOMER;

SELECT *
	FROM FARA82.CUSTOMER
	WHERE REP_ID IS NULL;

SELECT CUST_FNAME, CUST_LNAME
	FROM FARA82.CUSTOMER
	WHERE CUST_LNAME = '';


INSERT INTO FARA82.CUSTOMER 
	VALUES('C0007', 'MIKE', NULL, 'R100');


INSERT INTO FARA82.PRODUCT (PRODUCT_ID)
	VALUES('P0001');


INSERT INTO FARA82.PRODUCT (PRODUCT_ID, PRODUCT_NAME)
	VALUES('P0002', '');

INSERT INTO FARA82.PRODUCT (PRODUCT_ID, PRODUCT_NAME)
	VALUES('P0003', NULL);

SELECT * 
	FROM FARA82.PRODUCT;

ALTER TABLE FARA82.CUSTOMER
	ADD CONSTRAINT FARA82.CUSTOMER_UK UNIQUE(CUST_FNAME);

INSERT INTO FARA82.CUSTOMER (CUST_ID, CUST_FNAME, CUST_LNAME, REP_ID)
	VALUES('C0010', 'FARHAD', 'POURHADI2', 'R100');


CREATE TABLE FARA82.CUSTOMER2 (
	CUST_ID	VARCHAR(10) CONSTRAINT FARA82.CUSTOMER2_PK PRIMARY KEY,
	CUST_FNAME	VARCHAR(50),
	CUST_LNAME	VARCHAR(50),
	CONSTRAINT FARA82.CUSTOMER2_UK UNIQUE(CUST_FNAME));

DROP TABLE FARA82.CUSTOMER2;

CREATE TABLE FARA82.CUSTOMER2 (
	CUST_ID	VARCHAR(10) CONSTRAINT FARA82.CUSTOMER2_PK PRIMARY KEY,
	CUST_FNAME	VARCHAR(50) CONSTRAINT FARA82.CUSTOMER2_UK UNIQUE,
	CUST_LNAME	VARCHAR(50));


DROP TABLE FARA82.PRODUCT;
SELECT * FROM FARA82.PRODUCT;
DELETE FROM FARA82.PRODUCT;
DROP TABLE FARA82.ORDER_DETAIL;
SELECT * FROM FARA82.ORDER_DETAIL;

COMMIT;



CREATE TABLE FARA82.PRODUCT (
	PRODUCT_ID	VARCHAR(10),
	PRODUCT_NAME	VARCHAR(50) DEFAULT 'NOT KNOWN',
	WH_NAME	VARCHAR(50) CONSTRAINT FARA82.WH_CHECK CHECK(WH_NAME IN ('TORONTO','MARKHAM'))

	 CONSTRAINT FARA82.PRODUCT_PK PRIMARY KEY(PRODUCT_ID));

CREATE TABLE FARA82.PRODUCT (
	PRODUCT_ID	VARCHAR(10),
	PRODUCT_NAME	VARCHAR(50) DEFAULT 'NOT KNOWN',
	WH_NAME	VARCHAR(50),
	 CONSTRAINT FARA82.WH_CHECK CHECK(WH_NAME IN ('TORONTO','MARKHAM')),
	 CONSTRAINT FARA82.PRODUCT_PK PRIMARY KEY(PRODUCT_ID));

INSERT INTO FARA82.PRODUCT (PRODUCT_ID, PRODUCT_NAME, WH_NAME)
	VALUES('P001', 'IRON','MARKHAM');


SELECT *
	FROM CUSTOMER
	WHERE CUST_FNAME = 'FARHAD' OR CUST_FNAME = 'MARY';

SELECT *
	FROM FARA82.CUSTOMER
	WHERE CUST_FNAME IN ('FARHAD', 'MARY','XX','MARYAM');

INSERT INTO FARA82.PRODUCT (PRODUCT_ID, PRODUCT_NAME, WH_NAME)
	VALUES
	('P001', 'IRON','MARKHAM'),
	('P002', 'IRON2','TORONTO'),
	('P003', 'IRON3','MARKHAM'),
	('P004', 'IRON4','MARKHAM'),
	('P005', 'IRON5','TORONTO');

ROLLBACK;

SELECT *
	FROM FARA82.PRODUCT;

UPDATE FARA82.PRODUCT
	SET  PRODUCT_NAME = 'PROD55',
	WH_NAME = 'MARKHAM'
	WHERE PRODUCT_ID = 'P002';

DELETE FROM FARA82.PRODUCT
	WHERE PRODUCT_ID IN ('P001','P002');

